#pragma once
#include "__unified_forward.h"
#include "jakt__platform.h"
#include "jakt__path.h"
#include "jakt__platform__posix_process.h"
namespace Jakt {
namespace build {
struct ParallelExecutionPool {
  public:
JaktInternal::Dictionary<size_t,jakt__platform__posix_process::Process> pids;JaktInternal::Dictionary<size_t,jakt__platform__posix_process::ExitPollResult> completed;size_t pid_index;size_t max_concurrent;static ErrorOr<build::ParallelExecutionPool> create(size_t const max_concurrent);
JaktInternal::Optional<jakt__platform__posix_process::ExitPollResult> status(size_t const id) const;
ParallelExecutionPool(JaktInternal::Dictionary<size_t,jakt__platform__posix_process::Process> a_pids, JaktInternal::Dictionary<size_t,jakt__platform__posix_process::ExitPollResult> a_completed, size_t a_pid_index, size_t a_max_concurrent);

ErrorOr<void> wait_for_any_job_to_complete();
ErrorOr<size_t> run(JaktInternal::DynamicArray<DeprecatedString> const args);
ErrorOr<void> kill_all();
ErrorOr<void> wait_for_all_jobs_to_complete();
ErrorOr<DeprecatedString> debug_description() const;
};struct Builder {
  public:
JaktInternal::DynamicArray<DeprecatedString> linked_files;JaktInternal::DynamicArray<DeprecatedString> files_to_compile;build::ParallelExecutionPool pool;ErrorOr<void> link_into_executable(DeprecatedString const cxx_compiler_path, DeprecatedString const output_filename, JaktInternal::DynamicArray<DeprecatedString> const extra_arguments);
static ErrorOr<build::Builder> for_building(JaktInternal::DynamicArray<DeprecatedString> const files, size_t const max_concurrent);
ErrorOr<void> link_into_archive(DeprecatedString const archiver, DeprecatedString const archive_filename);
Builder(JaktInternal::DynamicArray<DeprecatedString> a_linked_files, JaktInternal::DynamicArray<DeprecatedString> a_files_to_compile, build::ParallelExecutionPool a_pool);

ErrorOr<void> build_all(jakt__path::Path const binary_dir, Function<ErrorOr<JaktInternal::DynamicArray<DeprecatedString>>(DeprecatedString, DeprecatedString)> const& compiler_invocation);
ErrorOr<DeprecatedString> debug_description() const;
};}
} // namespace Jakt
template<>struct Jakt::Formatter<Jakt::build::ParallelExecutionPool> : Jakt::Formatter<Jakt::StringView>{
Jakt::ErrorOr<void> format(Jakt::FormatBuilder& builder, Jakt::build::ParallelExecutionPool const& value) {
JaktInternal::PrettyPrint::ScopedEnable pretty_print_enable { m_alternative_form };Jakt::ErrorOr<void> format_error = Jakt::Formatter<Jakt::StringView>::format(builder, MUST(value.debug_description()));return format_error;}
};
namespace Jakt {
} // namespace Jakt
template<>struct Jakt::Formatter<Jakt::build::Builder> : Jakt::Formatter<Jakt::StringView>{
Jakt::ErrorOr<void> format(Jakt::FormatBuilder& builder, Jakt::build::Builder const& value) {
JaktInternal::PrettyPrint::ScopedEnable pretty_print_enable { m_alternative_form };Jakt::ErrorOr<void> format_error = Jakt::Formatter<Jakt::StringView>::format(builder, MUST(value.debug_description()));return format_error;}
};
namespace Jakt {
} // namespace Jakt
