#include "jakt__platform__posix_fs.h"
namespace Jakt {
namespace jakt__platform__posix_fs {
ErrorOr<void> make_directory(DeprecatedString const path) {
{
int const rc = mkdir(((path).characters()),static_cast<u32>(511));
if (((rc) == (static_cast<int>(0)))){
return {};
}
return Error::from_errno(jakt__platform__posix_errno::errno_value());
}
return {};
}

ErrorOr<DeprecatedString> current_directory() {
{
size_t const buffer_size = static_cast<size_t>(4096ULL);
char* buffer = utility::allocate<char>(JaktInternal::checked_add(buffer_size,static_cast<size_t>(1ULL)));
ScopeGuard __jakt_var_0([&] {
{
{
free(buffer);
}

}

});
char* const buf = getcwd(buffer,buffer_size);
if ((buf == utility::null<char>())){
return Error::from_errno(jakt__platform__posix_errno::errno_value());
}
DeprecatedStringBuilder b = DeprecatedStringBuilder::create();
TRY((((b).append_c_string(buf))));
return TRY((((b).to_string())));
}
}

ErrorOr<DeprecatedString> jakt__platform__posix_fs::DirectoryIterator::debug_description() const { auto builder = DeprecatedStringBuilder::create();TRY(builder.append("DirectoryIterator("sv));{
JaktInternal::PrettyPrint::ScopedLevelIncrease increase_indent {};
TRY(JaktInternal::PrettyPrint::output_indentation(builder));TRY(builder.appendff("path: {}, ", path));
TRY(JaktInternal::PrettyPrint::output_indentation(builder));TRY(builder.appendff("dir_fd: {}", dir_fd));
}
TRY(builder.append(")"sv));return builder.to_string(); }
ErrorOr<JaktInternal::Optional<NonnullRefPtr<jakt__platform__posix_fs::DirectoryIterator>>> jakt__platform__posix_fs::DirectoryIterator::from_path(jakt__path::Path const path) {
{
DIR* const dir_fd = opendir(((((path).to_string())).characters()));
if ((dir_fd == utility::null<DIR>())){
return JaktInternal::OptionalNone();
}
return TRY((jakt__platform__posix_fs::DirectoryIterator::__jakt_create(path,dir_fd)));
}
}

ErrorOr<JaktInternal::Optional<JaktInternal::Tuple<jakt__path::Path,bool>>> jakt__platform__posix_fs::DirectoryIterator::next() {
{
dirent* const file = readdir(((*this).dir_fd));
if ((file == utility::null<dirent>())){
closedir(((*this).dir_fd));
return JaktInternal::OptionalNone();
}
DeprecatedStringBuilder builder = DeprecatedStringBuilder::create();
bool is_directory = false;
{
TRY((((builder).append_c_string((((*(file))).d_name)))));
if ((*file).d_type == DT_DIR)is_directory = true;
}

DeprecatedString const filename = TRY((((builder).to_string())));
if ((((filename) == (TRY(DeprecatedString::from_utf8("."sv)))) || ((filename) == (TRY(DeprecatedString::from_utf8(".."sv)))))){
return TRY((((*this).next())));
}
return (Tuple{TRY((jakt__path::Path::from_string(filename))), is_directory});
}
}

jakt__path::Path jakt__platform__posix_fs::DirectoryIterator::get_path() const {
{
return ((*this).path);
}
}

jakt__platform__posix_fs::DirectoryIterator::DirectoryIterator(jakt__path::Path a_path, DIR* a_dir_fd): path(move(a_path)), dir_fd(move(a_dir_fd)){}
ErrorOr<NonnullRefPtr<DirectoryIterator>> jakt__platform__posix_fs::DirectoryIterator::__jakt_create(jakt__path::Path path, DIR* dir_fd) { auto o = TRY(adopt_nonnull_ref_or_enomem(new (nothrow) DirectoryIterator (move(path), move(dir_fd)))); return o; }
}
} // namespace Jakt
