#include "jakt__platform__posix_process.h"
namespace Jakt {
namespace jakt__platform__posix_process {
ErrorOr<jakt__platform__posix_process::Process> start_background_process(JaktInternal::DynamicArray<DeprecatedString> const args) {
{
char** call_args = utility::allocate<char*>(JaktInternal::checked_add(((args).size()),static_cast<size_t>(1ULL)));
ScopeGuard __jakt_var_1([&] {
{
{
free(call_args);
}

}

});
i64 i = static_cast<i64>(0LL);
{
JaktInternal::ArrayIterator<DeprecatedString> _magic = ((args).iterator());
for (;;){
JaktInternal::Optional<DeprecatedString> const _magic_value = ((_magic).next());
if ((!(((_magic_value).has_value())))){
break;
}
DeprecatedString arg = (_magic_value.value());
{
{
call_args[i++] = const_cast<char*>(arg.characters());
}

}

}
}

i32 const pid = fork();
if (((pid) == ((-(static_cast<i32>(1)))))){
return Error::from_errno(jakt__platform__posix_errno::errno_value());
}
if (((pid) == (static_cast<i32>(0)))){
i32 const rc = execvp(((((args)[static_cast<i64>(0LL)])).characters()),call_args);
warnln((StringView::from_string_literal("execvp returned rc = {}"sv)),rc);
return Error::from_errno(jakt__platform__posix_errno::errno_value());
}
return jakt__platform__posix_process::Process::create(pid);
}
}

ErrorOr<JaktInternal::Optional<jakt__platform__posix_process::ExitPollResult>> poll_process_exit(jakt__platform__posix_process::Process const& process) {
{
i32 status = static_cast<i32>(0);
i32 const result = waitpid(((((process))).pid),(const_cast<i32*>(&(status))),static_cast<i32>(1));
if (((result) == ((-(static_cast<i32>(1)))))){
return Error::from_errno(jakt__platform__posix_errno::errno_value());
}
if (((result) != (((((process))).pid)))){
return JaktInternal::OptionalNone();
}
if ((!((WIFEXITED(status) || WIFSIGNALED(status))))){
return JaktInternal::OptionalNone();
}
return jakt__platform__posix_process::ExitPollResult(WEXITSTATUS(status),((process)));
}
}

ErrorOr<void> forcefully_kill_process(jakt__platform__posix_process::Process const& process) {
{
kill(((((process))).pid),static_cast<i32>(9));
}
return {};
}

ErrorOr<JaktInternal::Tuple<JaktInternal::Optional<size_t>,jakt__platform__posix_process::ExitPollResult>> wait_for_some_set_of_processes_that_at_least_includes(JaktInternal::Dictionary<size_t,jakt__platform__posix_process::Process> const& processes) {
{
if (((((processes))).is_empty())){
return Error::from_errno(static_cast<i32>(38));
}
i32 status = static_cast<i32>(0);
i32 const result = waitpid((-(static_cast<i32>(1))),(const_cast<i32*>(&(status))),static_cast<i32>(0));
if (((result) == ((-(static_cast<i32>(1)))))){
return Error::from_errno(jakt__platform__posix_errno::errno_value());
}
JaktInternal::Optional<size_t> const key = JaktInternal::OptionalNone();
return (Tuple{key, jakt__platform__posix_process::ExitPollResult(WEXITSTATUS(status),jakt__platform__posix_process::Process(result))});
}
}

ErrorOr<jakt__platform__posix_process::ExitPollResult> wait_for_process(jakt__platform__posix_process::Process const& process) {
{
i32 status = static_cast<i32>(0);
i32 const result = waitpid(((((process))).pid),(const_cast<i32*>(&(status))),static_cast<i32>(0));
if (((result) == ((-(static_cast<i32>(1)))))){
return Error::from_errno(jakt__platform__posix_errno::errno_value());
}
return jakt__platform__posix_process::ExitPollResult(WEXITSTATUS(status),((process)));
}
}

ErrorOr<DeprecatedString> jakt__platform__posix_process::Process::debug_description() const { auto builder = DeprecatedStringBuilder::create();TRY(builder.append("Process("sv));{
JaktInternal::PrettyPrint::ScopedLevelIncrease increase_indent {};
TRY(JaktInternal::PrettyPrint::output_indentation(builder));TRY(builder.appendff("pid: {}", pid));
}
TRY(builder.append(")"sv));return builder.to_string(); }
jakt__platform__posix_process::Process jakt__platform__posix_process::Process::create(i32 const pid) {
{
return jakt__platform__posix_process::Process(pid);
}
}

jakt__platform__posix_process::Process::Process(i32 a_pid) :pid(move(a_pid)){}

ErrorOr<DeprecatedString> jakt__platform__posix_process::ExitPollResult::debug_description() const { auto builder = DeprecatedStringBuilder::create();TRY(builder.append("ExitPollResult("sv));{
JaktInternal::PrettyPrint::ScopedLevelIncrease increase_indent {};
TRY(JaktInternal::PrettyPrint::output_indentation(builder));TRY(builder.appendff("exit_code: {}, ", exit_code));
TRY(JaktInternal::PrettyPrint::output_indentation(builder));TRY(builder.appendff("process: {}", process));
}
TRY(builder.append(")"sv));return builder.to_string(); }
jakt__platform__posix_process::ExitPollResult::ExitPollResult(i32 a_exit_code, jakt__platform__posix_process::Process a_process) :exit_code(move(a_exit_code)), process(move(a_process)){}

}
} // namespace Jakt
