#include "platform__posix_compiler.h"
namespace Jakt {
namespace platform__posix_compiler {
ErrorOr<JaktInternal::DynamicArray<DeprecatedString>> run_compiler(DeprecatedString const cxx_compiler_path,DeprecatedString const cpp_filename,DeprecatedString const output_filename,DeprecatedString const runtime_path,JaktInternal::DynamicArray<DeprecatedString> const extra_include_paths,JaktInternal::DynamicArray<DeprecatedString> const extra_lib_paths,JaktInternal::DynamicArray<DeprecatedString> const extra_link_libs,bool const optimize,JaktInternal::DynamicArray<DeprecatedString> const extra_compiler_flags) {
{
jakt__path::Path file_path = TRY((jakt__path::Path::from_string(cxx_compiler_path)));
JaktInternal::DynamicArray<DeprecatedString> extra_flags = (TRY((DynamicArray<DeprecatedString>::create_with({}))));
if (((TRY((((file_path).basename(false))))) == (TRY(DeprecatedString::from_utf8("g++"sv))))){
TRY((((extra_flags).push(TRY(DeprecatedString::from_utf8("-Wno-literal-suffix"sv))))));
TRY((((extra_flags).push(TRY(DeprecatedString::from_utf8("-Wno-unused-parameter"sv))))));
TRY((((extra_flags).push(TRY(DeprecatedString::from_utf8("-Wno-unused-but-set-variable"sv))))));
TRY((((extra_flags).push(TRY(DeprecatedString::from_utf8("-Wno-unused-result"sv))))));
TRY((((extra_flags).push(TRY(DeprecatedString::from_utf8("-Wno-implicit-fallthrough"sv))))));
TRY((((extra_flags).push(TRY(DeprecatedString::from_utf8("-Wno-unused-command-line-argument"sv))))));
}
TRY((((extra_flags).push_values(((extra_compiler_flags))))));
JaktInternal::DynamicArray<DeprecatedString> compile_args = (TRY((DynamicArray<DeprecatedString>::create_with({cxx_compiler_path, TRY(DeprecatedString::from_utf8("-fdiagnostics-color=always"sv)), TRY(DeprecatedString::from_utf8("-std=c++20"sv)), TRY(DeprecatedString::from_utf8("-fno-exceptions"sv)), TRY(DeprecatedString::from_utf8("-Wno-unknown-warning-option"sv)), TRY(DeprecatedString::from_utf8("-Wno-trigraphs"sv)), TRY(DeprecatedString::from_utf8("-Wno-parentheses-equality"sv)), TRY(DeprecatedString::from_utf8("-Wno-unqualified-std-cast-call"sv)), TRY(DeprecatedString::from_utf8("-Wno-user-defined-literals"sv)), TRY(DeprecatedString::from_utf8("-Wno-deprecated-declarations"sv)), TRY(DeprecatedString::from_utf8("-g"sv))}))));
if (optimize){
TRY((((compile_args).push(TRY(DeprecatedString::from_utf8("-O3"sv))))));
}
if ((!(((extra_flags).is_empty())))){
TRY((((compile_args).push_values(((extra_flags))))));
}
TRY((((compile_args).push(TRY(DeprecatedString::from_utf8("-I"sv))))));
TRY((((compile_args).push(runtime_path))));
TRY((((compile_args).push(TRY(DeprecatedString::from_utf8("-o"sv))))));
TRY((((compile_args).push(output_filename))));
TRY((((compile_args).push(cpp_filename))));
if ((!(((extra_include_paths).is_empty())))){
TRY((((compile_args).add_capacity(JaktInternal::checked_mul(((extra_include_paths).size()),static_cast<size_t>(2ULL))))));
{
JaktInternal::ArrayIterator<DeprecatedString> _magic = ((extra_include_paths).iterator());
for (;;){
JaktInternal::Optional<DeprecatedString> const _magic_value = ((_magic).next());
if ((!(((_magic_value).has_value())))){
break;
}
DeprecatedString path = (_magic_value.value());
{
TRY((((compile_args).push(TRY(DeprecatedString::from_utf8("-I"sv))))));
TRY((((compile_args).push(path))));
}

}
}

}
if ((!(((extra_lib_paths).is_empty())))){
TRY((((compile_args).add_capacity(JaktInternal::checked_mul(((extra_lib_paths).size()),static_cast<size_t>(2ULL))))));
{
JaktInternal::ArrayIterator<DeprecatedString> _magic = ((extra_lib_paths).iterator());
for (;;){
JaktInternal::Optional<DeprecatedString> const _magic_value = ((_magic).next());
if ((!(((_magic_value).has_value())))){
break;
}
DeprecatedString path = (_magic_value.value());
{
TRY((((compile_args).push(TRY(DeprecatedString::from_utf8("-L"sv))))));
TRY((((compile_args).push(path))));
}

}
}

}
if ((!(((extra_link_libs).is_empty())))){
TRY((((compile_args).add_capacity(((extra_link_libs).size())))));
{
JaktInternal::ArrayIterator<DeprecatedString> _magic = ((extra_link_libs).iterator());
for (;;){
JaktInternal::Optional<DeprecatedString> const _magic_value = ((_magic).next());
if ((!(((_magic_value).has_value())))){
break;
}
DeprecatedString path = (_magic_value.value());
{
TRY((((compile_args).push(TRY((((TRY(DeprecatedString::from_utf8("-l"sv))) + (path))))))));
}

}
}

}
return compile_args;
}
}

}
} // namespace Jakt
